/* -*- Mode: Fundamental -*-
   
   This file is part of Scrunitizer - the C++ Unit Test Framework
   Copyright (C) 2000  Bernd Linowski
   (scrunitizer@linosphere.de)
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or any later version.
   
   This framework is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   

   Version 0.1 / Last changed: 13.02.00
*/


#ifndef _QX_PROGRESS_CYLINDER_H_
#define _QX_PROGRESS_CYLINDER_H_

#include <qprogressbar.h>


class QXProgressCylinder : public QProgressBar {

//	Q_OBJECT

	private:
		QColor		_cylinderColor;		// 0, 0, 200
		double		_lightAngle;		// 45.0 [0.0, 180.0]
		double		_cylinderDarkening;	// 0.5	[0.0, 1.0]
		double		_grooveDarkening;	// 0.7	[0.0, 1.0]
		int		_cylinderReflectPower;	// 12	[1, +inf)
		int		_grooveReflectPower;	// 8	[1, +inf)
		double		_grooveRelighting;	// 0.5	[0.0, 1.0]

	public:
		QXProgressCylinder (QWidget* parent = 0, const char* name = 0, WFlags f = 0);
		QXProgressCylinder (int totalSteps, QWidget* parent = 0, const char* name = 0, WFlags f=0);

	public:
		virtual QColor& cylinderColor ();
		virtual void setCylinderColor (QColor&);
		virtual void getLighting (double& lightAngle, 
					  double& cylinderDarkening, double& grooveDarkening,
					  int& cylinderReflectPower, int& grooveReflectPower,
					  double& grooveRelighting);
		virtual void setLighting (double lightAngle, 
					  double cylinderDarkening, double grooveDarkening,
					  int cylinderReflectPower, int grooveReflectPower,
					  double grooveRelighting);

	protected:
		virtual void drawContents (QPainter*);
		virtual void drawContentsMask (QPainter*);
		virtual bool setIndicator (QString& progress_str, int progress, int totalSteps);
		virtual void styleChange (QStyle&);
};


#endif
