/* -*- Mode: Fundamental -*-
   
   This file is part of Scrunitizer - the C++ Unit Test Framework
   Copyright (C) 2000  Bernd Linowski
   (scrunitizer@linosphere.de)
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or any later version.
   
   This framework is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   

   Version 0.3 / Last changed: 04.05.00
*/


#include <string>

#include <TestExceptionRecord.hh>


namespace Scrunitizer {


TestExceptionRecord::TestExceptionRecord (
	Test*		origin,
	TestException*	exception,
	TestPhase	phase,
	bool		release
) : _origin (origin), _exception (exception), _phase (phase), _release (release) {
}


TestExceptionRecord::~TestExceptionRecord () {
	if (_release) delete _exception;
}


bool less (TestExceptionRecord* lhs, TestExceptionRecord* rhs) {
	int cmp = ((lhs->getOrigin ())->getName ()).compare ((rhs->getOrigin ())->getName ());
	if (cmp != 0) return cmp < 0;

	if ((lhs->getException ())->isError ()) {
		if (! (rhs->getException ())->isError ()) return true;
	} else {
		if (  (rhs->getException ())->isError ()) return false;
	}

	return (lhs->getException ())->getMessage () < (rhs->getException ())->getMessage ();	
}


} // End of namespace Scrunitizer
