/* -*- Mode: Fundamental -*-
   
   This file is part of Scrunitizer - the C++ Unit Test Framework
   Copyright (C) 2000  Bernd Linowski
   (scrunitizer@linosphere.de)
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or any later version.
   
   This framework is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   

   Version 0.4 / Last changed: 01.11.00
*/

#ifndef _TEST_FIXTURE_H_
#define _TEST_FIXTURE_H_


namespace Scrunitizer {


//: Abstract class for test fixture implementations.
// A test fixture is a class that combines several test member functions.
// Fixture instances could be handed over to the TestManager so that they are
// deleted when the test manager is deleted
//
class TestFixture {

	public:
		//: Destructor.
		// Enforces that the fixture class also has a virtual constructor.
		//
		virtual ~TestFixture () {}


};


} // End of namespace Scrunitizer

#endif
